/*Ingresa una matriz booleana cuadrada que indica que persona conoce a que persona
 * La idea es buscar un numero K tal que la K-ésima fila tiene puros ceros salvo en la posicion K-K y
 * la K-ésima columna tiene puros unos
 * 
 * Empezamos a hacer comparaciones, si encontramos un uno, bajamos a la siguiente fila, en caso contrario, 
 * pasamos a la siguiente columna. Se esperaría que al llegar a un borde de la matriz, la fila o columna correspondiente
 * puede ser una celebridad.
 * 
 * Por ultimo hay que verificar que se trata de una celebridad.
 * 
 * Orden del algoritmo O(n)*/
int encontrarCelebridad(boolean[][] A, int n){
	int i = 0;
	int j = 1;
	int next = 2;
	int candidato;
	
	//Buscamos el extremo de la matriz
	while(next < n){
		if(A[i][j])
			i = next;
		else
			j = next;
		next++;
	}
	
	//Seleccionamos el candidato
	if(i==n)
		candidato = j;
	else
		candidato = i;
	
	//Verificacion del candidato
	boolean flag = false;
	int k = 0;
	
	A[candidato][candidato] = false;
	
	while(!flag && k < n){
		if(A[candidato][k])
			flag = true;
		if(!A[k][candidato])
			if(candidato != k)
				flag = true;
		k++;
	}
	
	if(!flag)
		return candidato;
	else
		return -1;
}
