/*La idea en este problema es partir el arreglo en dos, contar las inversiones de cada mitad y luego
 * contar las inversiones ocurridas entre elementos de cada mitad. Ademas, cada vez que un subarreglo se procesa,
 * este se devuelve ordenado para facilitar el conteo de inversiones entre mitades disjuntas.
 * 
 * El algoritmo tiene un orden de O(nlogn)*/
int numInversiones(int A[], int p, int r){
	int suma1;
	int suma2;
	int suma = 0;
	
	if(p < r){
		int q = (p+r)/2;
		suma1 = numInversiones(A,p,q); //Retorna el numero de inversiones de la mitad izquierda
		suma2 = numInversiones(A, q+1, r); // Retorna el numero de inversiones de la mitad derecha
		suma = suma1 + suma2 + contar_inversiones(A, p,q,r); //Cuenta inversiones entre mitades
		fusionar(A, p, q, r); //Fusiona las dos mitades ordenadas
	}
	
	return suma;
}

/*Dado un arreglo, partido en dos subarreglo A[p..q] y A[q+1..r], se fusiona en un solo arreglo ordenado*/
void fusionar(int A[], int p, int q, int r){
	int n1 = q-p+1;
	int n2 = r-q;
	
	int L1[n1+1];
	int L2[n2+1];
	
	for(int i = 0; i < n1; i++)
		L1[i] = A[p+i];
	L1[n1] = 10000000;
	
	for(int i = 0; i < n2; i++)
		L2[i] = A[q+i+1];
	L2[n2] = 10000000;
	
	int k = 0;
	int j = 0;
	
	for(int i = p; i <= r; i++){
		if(L1[k] < L2[j])
			A[i] = L1[k++];
		else
			A[i] = L2[j++];
	}
}

/*Se cuenta el numero de inversiones entre dos subarreglos*/
int contar_inversiones(int A[], int p, int q, int r){
	int i = p;
	int j = q+1;
	
	int suma = 0;
	while(i <= q && j <= r){
		if(A[i] < = A[j])
			i++;
		else{
			suma = suma + (q-i+1);
			j++;
		}
	}
	
	return suma;
}
